<?php

//convertit une image en binaire, 1=pixel, 0=pas pixel(blanc)
function GenererImageEnBinaire ($x, $y, $width, $height, $im, $contrast, $maxwidth, $maxheight)
{
	$tabBinaire = array();
	$tabBinaireLigne = array();
	$hauteur = imagesy($im);
	$largeur = imagesx($im);

	for ( $j=$y ; $j<$maxheight ; $j++ )
	{
		$tabBinaireLigne = array();
		for ( $i=$x ; $i<$maxwidth ; $i++ )
		{

			$pixelrgb = imagecolorat($im,$i,$j);
			$cols = imagecolorsforindex($im, $pixelrgb);
			$r = $cols['red'];
			$g = $cols['green'];
			$b = $cols['blue'];

			if (($r+$g+$b)/3 < 255-$contrast)
				array_push($tabBinaireLigne,"1");
			else
				array_push($tabBinaireLigne,"0");
		}
		array_push($tabBinaire,$tabBinaireLigne);
	}
	return $tabBinaire;
}

function maximum($i,$j)
{
	if ($i>$j)
		return $i;
	else
		return $j;

}

function nbPixelInutilise_c_bg($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($pict[$i][$j]!='0' && $j>=1 && $i<$height-1)
	{
		$i++;
		$j--;
		if ($pict[$i][$j]=='1')
			$longueur++;
	}
	return $longueur;

}

function tracer_c_bg($pict,$i,$j,$height,$width)
{
	while ($j>=0 && $i<$height && $pict[$i][$j]!='0' )
	{
		$pict[$i][$j] = '2';
		$i++;
		$j--;
	}
	return $pict;

}

function nbPixelInutilise_c_b($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($pict[$i][$j]!='0' && $i<$height-1)
	{
		$i++;
		if ($pict[$i][$j]=='1')
			$longueur++;
	}
	return $longueur;

}

function tracer_c_b($pict,$i,$j,$height,$width)
{
	while ($i<$height && $pict[$i][$j]!='0')
	{
		$pict[$i][$j] = '2';
		$i++;
	}
	return $pict;

}

function nbPixelInutilise_c_bd($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($pict[$i][$j]!='0' && $i<$height-1 && $j<$width-1)
	{
		$j++;
		$i++;
		if ($pict[$i][$j]=='1')
			$longueur++;
	}
	return $longueur;

}

function tracer_c_bd($pict,$i,$j,$height,$width)
{
	while ( $i<$height && $j<$width && $pict[$i][$j]!='0')
	{
		$pict[$i][$j] = '2';
		$i++;
		$j++;
	}
	return $pict;

}


function nbPixelInutilise_c_d($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($pict[$i][$j]!='0' && $j<$width-1)
	{
		$j++;
		if ($pict[$i][$j]=='1')
			$longueur++;
	}
	return $longueur;

}

function tracer_c_d($pict,$i,$j,$height,$width)
{
	while ($j<$width && $pict[$i][$j]!='0')
	{
		$pict[$i][$j] = 2;
		$j++;
	}
	return $pict;

}


////////

function distance_c_bg($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($j>=0 && $i<$height && $pict[$i][$j]!='0')
	{
		$i++;
		$j--;
		$longueur++;
	}
	return $longueur-1;

}


function distance_c_b($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($i<$height && $pict[$i][$j]!='0')
	{
		$i++;
		$longueur++;
	}
	return $longueur-1;

}

function distance_c_bd($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($i<$height && $j<$width && $pict[$i][$j]!='0' )
	{
		$j++;
		$i++;
		$longueur++;
	}
	return $longueur-1;

}

function distance_c_d($pict,$i,$j,$height,$width)
{
	$longueur = 0;
	while ($j<$width && $pict[$i][$j]!='0')
	{
		$j++;
		$longueur++;
	}
	return $longueur-1;

}

function GegererImageFlinePlotLua($pict,$height,$width)
{
	$string = "";

	for ($i=0;$i<$height;$i++)
	{
		for ($j=0;$j<$width;$j++)
		{
			if ($pict[$i][$j] == '1') //on a un pixel que l'on peut encoder
			{
				$nbPixelInutilise_c_bg = nbPixelInutilise_c_bg($pict,$i,$j,$height,$width);
				$nbPixelInutilise_c_b = nbPixelInutilise_c_b($pict,$i,$j,$height,$width);
				$nbPixelInutilise_c_bd = nbPixelInutilise_c_bd($pict,$i,$j,$height,$width); 
				$nbPixelInutilise_c_d = nbPixelInutilise_c_d($pict,$i,$j,$height,$width);

				$distance_c_bg = distance_c_bg($pict,$i,$j,$height,$width);
				$distance_c_b = distance_c_b($pict,$i,$j,$height,$width);
				$distance_c_bd = distance_c_bd($pict,$i,$j,$height,$width); 
				$distance_c_d = distance_c_d($pict,$i,$j,$height,$width);
				if (isset($_POST["variableLua"]) && $_POST["variableLua"]==="on")
					$variable = true;
				else
					$variable = false;

				if ($nbPixelInutilise_c_bg==$nbPixelInutilise_c_b && $nbPixelInutilise_c_bd==$nbPixelInutilise_c_d && $nbPixelInutilise_c_bg==$nbPixelInutilise_c_bd && $nbPixelInutilise_c_bd==0)
				{
					$pict = tracer_c_bg($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "nbdraw.plot(a+". (string)($j) .",b+". (string)(64-$i) . ")";
					else
						$string = $string . "nbdraw.plot(". (string)($j) .",". (string)(64-$i) . ")";

				}
				else if ($nbPixelInutilise_c_bg == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_bg($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "nbdraw.line(a+". (string)($j) .",b+". (string)(64-$i) .",a+". (string)($j-$distance_c_bg) .",b+". (string)(64-$i-$distance_c_bg) . ")" ;
					else
						$string = $string . "nbdraw.line(". (string)($j) .",". (string)(64-$i) .",". (string)($j-$distance_c_bg) .",". (string)(64-$i-$distance_c_bg) . ")";

				}
				else if ($nbPixelInutilise_c_b == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_b($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "nbdraw.line(a+". (string)($j) .",b+". (string)(64-$i) .",a+". (string)($j) .",b+". (string)(64-$i-$distance_c_b) . ")" ;
					else
						$string = $string . "nbdraw.line(". (string)($j) .",". (string)(64-$i) .",". (string)($j) .",". (string)(64-$i-$distance_c_b) . ")";

				}
				else if ($nbPixelInutilise_c_bd == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_bd($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "nbdraw.line(a+". (string)($j) .",b+". (string)(64-$i) .",a+". (string)($j+$distance_c_bd) .",b+". (string)(64-$i-$distance_c_bd) . ")";
					else
						$string = $string . "nbdraw.line(". (string)($j) .",". (string)(64-$i) .",". (string)($j+$distance_c_bd) .",". (string)(64-$i-$distance_c_bd) . ")";

				}
				else
				{
					$pict = tracer_c_d($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "nbdraw.line(a+". (string)($j) .",b+". (string)(64-$i) .",a+". (string)($j+$distance_c_d) .",b+". (string)(64-$i) . ")";
					else
						$string = $string . "nbdraw.line(". (string)($j) .",". (string)(64-$i) .",". (string)($j+$distance_c_d) .",". (string)(64-$i) . ")";

				}
				$string = $string . "\n";
			}
		}

	}
	return $string;
}

function GegererImageFlinePlot($pict,$height,$width)
{
	$string = "";

	for ($i=0;$i<$height;$i++)
	{
		for ($j=0;$j<$width;$j++)
		{
			if ($pict[$i][$j] == '1') //on a un pixel que l'on peut encoder
			{
				$nbPixelInutilise_c_bg = nbPixelInutilise_c_bg($pict,$i,$j,$height,$width);
				$nbPixelInutilise_c_b = nbPixelInutilise_c_b($pict,$i,$j,$height,$width);
				$nbPixelInutilise_c_bd = nbPixelInutilise_c_bd($pict,$i,$j,$height,$width); 
				$nbPixelInutilise_c_d = nbPixelInutilise_c_d($pict,$i,$j,$height,$width);

				$distance_c_bg = distance_c_bg($pict,$i,$j,$height,$width);
				$distance_c_b = distance_c_b($pict,$i,$j,$height,$width);
				$distance_c_bd = distance_c_bd($pict,$i,$j,$height,$width); 
				$distance_c_d = distance_c_d($pict,$i,$j,$height,$width);
				//echo "SketchThin ";
				if (isset($_POST["variable"]) && $_POST["variable"]==="on")
					$variable = true;
				else
					$variable = false;

				if ($nbPixelInutilise_c_bg==$nbPixelInutilise_c_b && $nbPixelInutilise_c_bd==$nbPixelInutilise_c_d && $nbPixelInutilise_c_bg==$nbPixelInutilise_c_bd && $nbPixelInutilise_c_bd==0)
				{
					$pict = tracer_c_bg($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "PlotOn A+". (string)($j) .",B+". (string)(64-$i);
					else
						$string = $string . "PlotOn ". (string)($j) .",". (string)(64-$i);

				}
				else if ($nbPixelInutilise_c_bg == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_bg($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "F-Line A+". (string)($j) .",B+". (string)(64-$i) .",A+". (string)($j-$distance_c_bg) .",B+". (string)(64-$i-$distance_c_bg) ;
					else
						$string = $string . "F-Line ". (string)($j) .",". (string)(64-$i) .",". (string)($j-$distance_c_bg) .",". (string)(64-$i-$distance_c_bg);

				}
				else if ($nbPixelInutilise_c_b == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_b($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "F-Line A+". (string)($j) .",B+". (string)(64-$i) .",A+". (string)($j) .",B+". (string)(64-$i-$distance_c_b) ;
					else
						$string = $string . "F-Line ". (string)($j) .",". (string)(64-$i) .",". (string)($j) .",". (string)(64-$i-$distance_c_b);

				}
				else if ($nbPixelInutilise_c_bd == maximum( maximum($nbPixelInutilise_c_bg,$nbPixelInutilise_c_b) , maximum($nbPixelInutilise_c_bd,$nbPixelInutilise_c_d) ))
				{
					$pict = tracer_c_bd($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "F-Line A+". (string)($j) .",B+". (string)(64-$i) .",A+". (string)($j+$distance_c_bd) .",B+". (string)(64-$i-$distance_c_bd);
					else
						$string = $string . "F-Line ". (string)($j) .",". (string)(64-$i) .",". (string)($j+$distance_c_bd) .",". (string)(64-$i-$distance_c_bd);

				}
				else
				{
					$pict = tracer_c_d($pict,$i,$j,$height,$width);
					if ($variable)
						$string = $string . "F-Line A+". (string)($j) .",B+". (string)(64-$i) .",A+". (string)($j+$distance_c_d) .",B+". (string)(64-$i);
					else
						$string = $string . "F-Line ". (string)($j) .",". (string)(64-$i) .",". (string)($j+$distance_c_d) .",". (string)(64-$i);

				}
				$string = $string . "\n";
			}
		}

	}
	return $string;
}

function codeSpriteBasic($x, $y, $width, $height, $im, $maxwidth, $maxheight) //retourne sprite codé sous forme de string
{
	$string = "";
	$string = $string . "Cls\n";
	$imagePixel = GenererImageEnBinaire ($x, $y, $width, $height, $im, 125, $maxwidth, $maxheight);
	$string  = $string . GegererImageFlinePlot($imagePixel ,$height,$width);
	return $string;
}

function codeSpriteLua($x, $y, $width, $height, $im, $name, $maxwidth, $maxheight) //retourne sprite codé sous forme de string
{
	$string = "";
	$string = $string . "function ".$name."()\n";
	$imagePixel = GenererImageEnBinaire ($x, $y, $width, $height, $im, 125, $maxwidth, $maxheight);
	$string  = $string . GegererImageFlinePlotLua($imagePixel ,$height,$width);
	$string = $string . "end\n";
	return $string;
}


/*
nbdraw.line(x1,y1,x2,y2)
nbdraw.line (...)
..
end*/

?>